{open Agiparse;; exception Eof;; }

let word = ['a'-'z' 'A'-'Z' '0'-'9' '_']+
let chanword = ['a'-'z' 'A'-'Z' '0'-'9' '-']+
let number = ['-' '0'-'9']+
  rule token = parse
  [' ' '\t']     { token lexbuf }
| ['\n']    { EOL }
| ['A'-'Z']+ as com { COMMAND(com) }
| word '/' chanword as ch { CHAN(ch) }
| ['*' '0'-'9']+ as dig { DIGITS(dig) }
| number as num { INT(num) }
| ':'            { COLON }
|  '"' [^ '"']* '"' as s { STR(s) }
| '(' [^ '(']* ')' { token lexbuf }
| '<' number '>' as id { ID(id) } 
| [^ '/' ' ' '\t' '\n' '"' ':' '<' '>']+ as n { NAME(n) }
| eof            { raise Eof }
    
