%{ 
open String;;
open Commands;;

let flag = ref 0;
type data = { command: string; ret: string }
let h = Hashtbl.create 21;;
Hashtbl.add h ["GET";"DATA"] {command="GD"; ret="-1"};;
Hashtbl.add h ["STREAM";"FILE"] {command="SF"; ret="-1"};;
Hashtbl.add h ["ANSWER"] {command="A"; ret="-1"};;
Hashtbl.add h ["CHANNEL";"STATUS"] {command="CS"; ret="-1"};;
Hashtbl.add h ["EXEC"] {command="E"; ret="-1"};;
Hashtbl.add h ["HANGUP"] {command="H"; ret="-1"};;
Hashtbl.add h ["RECEIVE";"CHAR"] {command="RC"; ret="-1"};;
Hashtbl.add h ["SAY";"DIGITS"] {command="SD"; ret="-1"};;
Hashtbl.add h ["SAY";"NUMBER"] {command="SN"; ret="-1"};;
Hashtbl.add h ["SEND";"IMAGE"] {command="SI"; ret="-1"};;
Hashtbl.add h ["SEND";"TEXT"] {command="ST"; ret="-1"};;
Hashtbl.add h ["TDD";"MODE"] {command="TM"; ret="-1"};;
Hashtbl.add h ["WAIT";"FOR";"DIGIT"] {command="WFD"; ret="-1"};;
Hashtbl.add h ["RECORD"; "FILE"] {command="RF"; ret="0 (hangup)"};;
Hashtbl.add h ["GET";"VARIABLE"] {command="GV"; ret=""};;
Hashtbl.add h ["SET";"VARIABLE"] {command="SV"; ret=""};;
Hashtbl.add h ["VERBOSE"] {command="V"; ret=""};;
Hashtbl.add h ["AUTOHANGUP"] {command="AH"; ret=""};;
Hashtbl.add h ["SET";"PRIORITY"] {command="SP"; ret=""};;
Hashtbl.add h ["SET";"CONTEXT"] {command="SC"; ret=""};;
Hashtbl.add h ["SET";"CALLERID"] {command="SCI"; ret=""};;
Hashtbl.add h ["SET";"EXTENSION"] {command="SE"; ret=""};;

let com = {return="";hangup="";name=[];abbrev="";params=[]};;
%}

%token <string> INT
%token <string> DIGITS 
%token <string> COMMAND 
%token <string> CHAN 
%token <string> STR
%token <string> NAME
%token <string> ID
%token COLON
%token EOL
%start main
%type <Commands.commands> main
  %%
main:
  expr               {  ignore (com.return="");
                        ignore (com.hangup="");
                        ignore (com.name=[]);
                        ignore (com.abbrev="");
                        ignore (com.params=$1);
                      com }
expr:
  INT expr                      { [$1] @ $2 }
| DIGITS expr                   { [$1] @ $2 }
| COMMAND COMMAND COMMAND expr  { ignore (com.name <- [$1;$2;$3]);
                                  let c = (Hashtbl.find h com.name) in
                                  ignore (com.abbrev <- c.command);
                                  ignore (com.hangup <- c.ret);
                                  $4 }
| COMMAND COMMAND expr          { ignore (com.name <- [$1;$2]);
                                  let c = (Hashtbl.find h com.name) in
                                  ignore (com.abbrev <- c.command);
                                  ignore (com.hangup <- c.ret);
                                  $3 }
| COMMAND expr                  { ignore (com.name <- [$1]);
                                  let c = (Hashtbl.find h com.name) in
                                  ignore (com.abbrev <- c.command);
                                  ignore (com.hangup <- c.ret);
                                  $2 }
| CHAN expr                     { [$1] @ $2 }
| STR expr                      { [$1] @ $2 }
| NAME expr                     { [$1] @ $2}
| STR ID expr                   { [(concat "" [$1;$2])] @ $3}
| NAME ID expr                  { [(concat "" [$1;$2])] @ $3}
| ID expr                       { [$1] @ $2 }
| COLON expr                    
    { 
      let head = List.hd $2 in
      let s = if (String.get head 0) = '"' then
        (String.sub head 1 ((String.length head)-2)) else head in
      ignore (com.return <- (concat "" ["200 result=";s])); []

    }   
| EOL                           { [] };
